# CbcBranchCut Class Reference

Define a cut branching class. More...

`#include <CbcBranchCut.hpp>`

Inheritance diagram for CbcBranchCut:
[legend]
Collaboration diagram for CbcBranchCut:
[legend]

List of all members.

## Public Member Functions
| CbcBranchCut ()
| CbcBranchCut (CbcModel *model)
| In to maintain normal methods.
| CbcBranchCut (const CbcBranchCut &)
virtual CbcObject * | clone () const
| Clone.
CbcBranchCut & | operator= (const CbcBranchCut &rhs)
| ~CbcBranchCut ()
virtual double | infeasibility (const OsiBranchingInformation *info, int &preferredWay) const
| Infeasibility.
virtual void | feasibleRegion ()
| Set bounds to contain the current solution.
virtual bool | boundBranch () const
| Return true if branch created by object should fix variables.
virtual CbcBranchingObject * | createCbcBranch (OsiSolverInterface *solver, const OsiBranchingInformation *info, int way)
| Creates a branching object.
virtual CbcBranchingObject * | preferredNewFeasible () const
| Given a valid solution (with reduced costs, etc.
virtual CbcBranchingObject * | notPreferredNewFeasible () const
| Given a valid solution (with reduced costs, etc.
virtual void | resetBounds ()
| Reset original upper and lower bound values from the solver.

## Detailed Description

Define a cut branching class.

At present empty - all stuff in descendants

Definition at line 17 of file CbcBranchCut.hpp.

## Constructor & Destructor Documentation

CbcBranchCut::CbcBranchCut | ( |  | ) |

CbcBranchCut::CbcBranchCut | ( | CbcModel * | model | ) |

In to maintain normal methods.

CbcBranchCut::CbcBranchCut | ( | const CbcBranchCut & |  | ) |

CbcBranchCut::~CbcBranchCut | ( |  | ) |

## Member Function Documentation

virtual CbcObject* CbcBranchCut::clone | ( |  | ) | const`[virtual]`

Clone.

Implements CbcObject.

Reimplemented in CbcBranchAllDifferent, and CbcBranchToFixLots.

CbcBranchCut& CbcBranchCut::operator= | ( | const CbcBranchCut & | rhs | ) |

Reimplemented from CbcObject.

Reimplemented in CbcBranchAllDifferent, and CbcBranchToFixLots.

virtual double CbcBranchCut::infeasibility | ( | const OsiBranchingInformation * | info,
|  | int & | preferredWay |
| ) |  |  | const`[virtual]`

Infeasibility.

Reimplemented from CbcObject.

Reimplemented in CbcBranchAllDifferent, and CbcBranchToFixLots.

virtual void CbcBranchCut::feasibleRegion | ( |  | ) | `[virtual]`

Set bounds to contain the current solution.

More precisely, for the variable associated with this object, take the value given in the current solution, force it within the current bounds if required, then set the bounds to fix the variable at the integer nearest the solution value.

At present this will do nothing

Implements CbcObject.

virtual bool CbcBranchCut::boundBranch | ( |  | ) | const`[virtual]`

Return true if branch created by object should fix variables.

Reimplemented from OsiObject.

virtual CbcBranchingObject* CbcBranchCut::createCbcBranch | ( | OsiSolverInterface * | solver,
|  | const OsiBranchingInformation * | info,
|  | int | way |
| ) |  |  | `[virtual]`

Creates a branching object.

Reimplemented from CbcObject.

Reimplemented in CbcBranchAllDifferent, and CbcBranchToFixLots.

virtual CbcBranchingObject* CbcBranchCut::preferredNewFeasible | ( |  | ) | const`[virtual]`

Given a valid solution (with reduced costs, etc.

), return a branching object which would give a new feasible point in the good direction.

The preferred branching object will force the variable to be +/-1 from its current value, depending on the reduced cost and objective sense. If movement in the direction which improves the objective is impossible due to bounds on the variable, the branching object will move in the other direction. If no movement is possible, the method returns NULL.

Only the bounds on this variable are considered when determining if the new point is feasible.

At present this does nothing

Reimplemented from CbcObject.

virtual CbcBranchingObject* CbcBranchCut::notPreferredNewFeasible | ( |  | ) | const`[virtual]`

Given a valid solution (with reduced costs, etc.

), return a branching object which would give a new feasible point in a bad direction.

As for preferredNewFeasible(), but the preferred branching object will force movement in a direction that degrades the objective.

At present this does nothing

Reimplemented from CbcObject.

virtual void CbcBranchCut::resetBounds | ( |  | ) | `[virtual]`

Reset original upper and lower bound values from the solver.

Handy for updating bounds held in this object after bounds held in the solver have been tightened.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.7.8/Cbc/src/CbcBranchCut.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines